// implementation of class CGUILoadOptsDialog

#include "util.h"
#include "crrc_loadopts.h"
#include "../crrc_main_cpp.h"
#include "../crrc_main.h"
#include "../windfield.h"
#include "../crrc_graphics.h"

#include <iostream>

static void CGUILoadOptsCallback(puObject *obj);

#define BUTTON_BOX_HEIGHT   (2*DLG_DEF_SPACE+DLG_DEF_BUTTON_HEIGHT)

CGUILoadOptsDialog::CGUILoadOptsDialog(std::string fname, SimpleXMLTransfer* xml)
            : CRRCDialog(), cbox(NULL)
{
  filename = fname;
  theXml = xml;
  
  // Load options
  optsGrpGraphics = xml->getChild("options.graphics");
  optsGraphics    = T_GUI_Util::loadnames(optsGrpGraphics, nOptsGraphics, false);
  optsGrpConfig   = xml->getChild("options.config");
  optsConfig      = T_GUI_Util::loadnames(optsGrpConfig, nOptsConfig, false);
  
  // Create widgets
  gbox = new puComboBox( 30, 2*BUTTON_BOX_HEIGHT + 2*DLG_DEF_SPACE,
                        410, 2*BUTTON_BOX_HEIGHT + DLG_DEF_BUTTON_HEIGHT + 2*DLG_DEF_SPACE,
                        optsGraphics, false);
  gbox->setLabelPlace(PUPLACE_TOP_LEFT);
  gbox->setLabel("Select graphics:");
  gbox->setCurrentItem(0);
  
  cbox = new puComboBox( 30, BUTTON_BOX_HEIGHT + DLG_DEF_SPACE,
                        410, BUTTON_BOX_HEIGHT + DLG_DEF_BUTTON_HEIGHT + DLG_DEF_SPACE,
                        optsConfig, false);
  cbox->setLabelPlace(PUPLACE_TOP_LEFT);
  cbox->setLabel("Select config:");
  cbox->setCurrentItem(0);
  
  close();
  setSize(440,3*BUTTON_BOX_HEIGHT + DLG_DEF_BUTTON_HEIGHT + 2*DLG_DEF_SPACE);
  setCallback(CGUILoadOptsCallback);
  
  
  // center the dialog on screen
  int wwidth, wheight;
  int current_width = getABox()->max[0] - getABox()->min[0];
  int current_height = getABox()->max[1] - getABox()->min[1];
  puGetWindowSize(&wwidth, &wheight);
  setPosition(wwidth/2 - current_width/2, wheight*2/3 - current_height);

  reveal();
}


/**
 * Destroy the dialog.
 */

CGUILoadOptsDialog::~CGUILoadOptsDialog()
{
}

/** \brief The dialog's callback.
 *
 */
void CGUILoadOptsCallback(puObject *obj)
{
  CGUILoadOptsDialog* dlg = (CGUILoadOptsDialog*)obj;

  if (obj->getIntegerValue() == CRRC_DIALOG_OK)
  {
    dlg->optsGrpGraphics->setAttributeOverwrite("opt", dlg->gbox->getCurrentItem());
    dlg->optsGrpConfig  ->setAttributeOverwrite("opt", dlg->cbox->getCurrentItem());
  }

  gui->hide();
  post_loadAirplane(dlg->filename, dlg->theXml);
  Simulation->reset();

  puDeleteObject(obj);
}
