#include "crrc_mouseaxis.h"

#include <stdio.h>
#include <stdlib.h>

#include "../crrc_main_cpp.h"
#include "../crrc_main.h"
#include "../mouse_kbd.h"

static void CGUIMouseAxisCallback(puObject *obj);

static char      *AxisNames[]      = {(char*)AxisStrings[0], (char*)AxisStrings[1],
                                      (char*)AxisStrings[2], (char*)AxisStrings[3],
                                      (char*)AxisStrings[4], NULL};


#define BUTTON_BOX_HEIGHT   (2*DLG_DEF_SPACE+DLG_DEF_BUTTON_HEIGHT)
#define COMBO_W  150
#define COMBO_H   20
#define LABEL_W  170


CGUIMouseAxisDialog::CGUIMouseAxisDialog()
            : CRRCDialog()
{
  
  combo_x = new puComboBox(LABEL_W + DLG_DEF_SPACE, BUTTON_BOX_HEIGHT + 1*DLG_DEF_SPACE + 1*COMBO_H,
                           LABEL_W + COMBO_W,       BUTTON_BOX_HEIGHT + 1*DLG_DEF_SPACE + 2*COMBO_H,
                           AxisNames, false);
  combo_x->setLabelPlace(PUPLACE_LOWER_LEFT);
  combo_x->setLabel("X");  
  combo_x->setCurrentItem(inputDev.mouse_bind_x);


  combo_y = new puComboBox(LABEL_W + DLG_DEF_SPACE, BUTTON_BOX_HEIGHT + 0*DLG_DEF_SPACE + 0*COMBO_H,
                           LABEL_W + COMBO_W,       BUTTON_BOX_HEIGHT + 0*DLG_DEF_SPACE + 1*COMBO_H,
                           AxisNames, false);
  combo_y->setLabelPlace(PUPLACE_LOWER_LEFT);
  combo_y->setLabel("Y");
  combo_y->setCurrentItem(inputDev.mouse_bind_y);

  close();
  setSize(COMBO_W + LABEL_W + 2*DLG_DEF_SPACE, 
          2*COMBO_H + 3*DLG_DEF_SPACE + BUTTON_BOX_HEIGHT);
  setCallback(CGUIMouseAxisCallback);
  
  // center the dialog on screen: doesn't work well, as the combo box 
  // when expanded upwards, seems to influence getABox -- but also getBBox,
  // so using that doesn't help.
  int wwidth, wheight;
  int current_width = getABox()->max[0] - getABox()->min[0];
  int current_height = getABox()->max[1] - getABox()->min[1];
  puGetWindowSize(&wwidth, &wheight);
  setPosition(wwidth/2 - current_width/2, wheight/2 - current_height/2);

  reveal();
}


/**
 * Destroy the dialog.
 */

CGUIMouseAxisDialog::~CGUIMouseAxisDialog()
{
}


/** \brief The dialog's callback.
 *
 */
void CGUIMouseAxisCallback(puObject *obj)
{
  if (obj->getIntegerValue() == CRRC_DIALOG_OK)
  {    
    // Dialog left by clicking OK
    CGUIMouseAxisDialog* dlg = (CGUIMouseAxisDialog*)obj;
    
    inputDev.mouse_bind_x = dlg->combo_x->getCurrentItem();
    inputDev.mouse_bind_y = dlg->combo_y->getCurrentItem();
  }
  
  puDeleteObject(obj);
}
