#ifndef AUDIO_RC_H
#define AUDIO_RC_H
/**
 *****************************************************************************
 * \file audio_rc.h
  Title: audio signal acquisition from radio control transmitter
  Authors:  Joel Lienard
            Lionel Cailler
 
  Purpose:  Audio signal acquisition from radio control transmitter.
  This code is based on origianl  Joel Lienard source code modified to support a
  portable library to a wide list of operating systems : http://www.portaudio.com

  It's free, it works, enjoy.  This  is an open source project, so if you  don't
  like the way something works, help us fix it!

 *
 *****************************************************************************
 */
#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

#if COMPILE_AUDIO_INTERFACE != 0  

#include "tx_audio.h"

int get_data_from_audio_interface(float *values);
int audio_rc_open(T_TX_InterfaceAudio *iface);
int audio_rc_close();
  
/**
 * return sample number i of  synchronised audio signal
 */
float get_audio_signal( int i);

#endif
  
  
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* AUDIO_RC_H */

