#include "xmlmodelfile.h"

#include <string>
#include <iostream>

namespace XMLModelFile
{

  bool ListOptions(SimpleXMLTransfer* xml)
  {
    SimpleXMLTransfer* it;
    SimpleXMLTransfer* e;
    SimpleXMLTransfer* grp;
    SimpleXMLTransfer* cfg;
    SimpleXMLTransfer* opt;
    unsigned int       uSize;

    opt = new SimpleXMLTransfer();
    opt->setName("options");
    grp = new SimpleXMLTransfer();
    grp->setName("graphics");
    grp->setAttribute("opt", "0");
    cfg = new SimpleXMLTransfer();
    cfg->setName("config");
    cfg->setAttribute("opt", "0");
    opt->addChild(grp);
    opt->addChild(cfg);
    xml->addChild(opt);

    uSize = xml->getChildCount();

    for (unsigned int uCnt=0; uCnt<uSize; uCnt++)
    {
      it = xml->getChildAt(uCnt);

      if (it->getName().compare("graphics") == 0)
      {
        e = new SimpleXMLTransfer();
        e->setName("graphics");
        // todo: maybe use other languages (if available and configured?)
        e->setContent(it->getChild("descr_short.en")->getContentString());
        grp->addChild(e);
      }
      else if (it->getName().compare("config") == 0)
      {
        e = new SimpleXMLTransfer();
        e->setName("config");
        // todo: maybe use other languages (if available and configured?)
        e->setContent(it->getChild("descr_short.en")->getContentString());
        cfg->addChild(e);
      }
    }
    // debug: show options
    //std::cout << "Options:\n";
    //opt->print(std::cout, 5);

    return(cfg->getChildCount() > 1 || grp->getChildCount() > 1);
  }

  SimpleXMLTransfer* getGraphics(SimpleXMLTransfer* xml)
  {
    // which one to use?
    int                nNr   = xml->getInt("options.graphics.opt");
    unsigned int       uSize = xml->getChildCount();
    SimpleXMLTransfer* it;
    SimpleXMLTransfer* first = (SimpleXMLTransfer*)0;
    int                nGCnt = -1;

    for (unsigned int uCnt=0; uCnt<uSize; uCnt++)
    {
      it = xml->getChildAt(uCnt);

      if (it->getName().compare("graphics") == 0)
      {
        if (first == (SimpleXMLTransfer*)0)
          first = it;
        
        nGCnt++;
        if (nGCnt == nNr)
          return(it);
      }
    }
    
    return(first);
  }

  SimpleXMLTransfer* getConfig(SimpleXMLTransfer* xml)
  {
    // which one to use?
    int                nNr   = xml->getInt("options.config.opt");
    unsigned int       uSize = xml->getChildCount();
    SimpleXMLTransfer* it;
    SimpleXMLTransfer* first = (SimpleXMLTransfer*)0;
    int                nGCnt = -1;

    for (unsigned int uCnt=0; uCnt<uSize; uCnt++)
    {
      it = xml->getChildAt(uCnt);

      if (it->getName().compare("config") == 0)
      {
        if (first == (SimpleXMLTransfer*)0)
          first = it;
        
        nGCnt++;
        if (nGCnt == nNr)
          return(it);
      }
    }
    return(first);
  }

};
